/* Sistemas Integrados TECNISA

Nome: 0212_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   26/02/2004 - Jenilson
*/


/* Tabela PARTFILI: Particularidade da Filial*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela de PARTFILI*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Particularidade da Filial,
             utilizando a tabela Geral de Logs de Operaes*/
CREATE OR REPLACE TRIGGER LOG_SUP_PARTFILI
AFTER DELETE OR INSERT OR UPDATE
ON PARTFILI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC   := 'Filial '    || '' || NVL(:NEW.CDFILIAL,'')   || ' ' ||
                  'Produto '   || '' || NVL(:NEW.CDPRODUTO,'')  || ' ' ||
                  'Tipo '      || '' || NVL(:NEW.CDTIPPART,'')  || ' ' ||
                  'Sequencial '|| '' || NVL(:NEW.NRSEQPART,'')  || ' ' ||
                  'Marca '     || '' || NVL(:NEW.CDMARCA,'')     || ' ' ||
                  'Forne '     || '' || NVL(:NEW.CDFORNECED,'')  || ' ' ||
                  'GrupProd '  || '' || NVL(:NEW.CDGRUPPROD,'')  || ' ' ||
                  'SubGrProd ' || '' || NVL(:NEW.CDSUBGRPROD,'') || ' ' ||
                  'FiliSubGr ' || '' || NVL(:NEW.CDFILISUBGR,'') || ' ' ||
                  'FilCota '   || '' || NVL(:NEW.CDFILCOTA,'')   || ' ' ||
                  'ColePreco ' || '' || NVL(:NEW.NRCOLEPRECO,'');
      V_ITPESQ       := :NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDTIPPART||:NEW.NRSEQPART;
      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Filial '    || '' || NVL(:NEW.CDFILIAL,'')   || ' ' ||
                     'Produto '   || '' || NVL(:NEW.CDPRODUTO,'')  || ' ' ||
                     'Tipo '      || '' || NVL(:NEW.CDTIPPART,'')  || ' ' ||
                     'Sequencial '|| '' || NVL(:NEW.NRSEQPART,'')  || ' ' ||
                     'Marca '     || '' || NVL(:NEW.CDMARCA,'')     || ' ' ||
                     'Forne '     || '' || NVL(:NEW.CDFORNECED,'')  || ' ' ||
                     'GrupProd '  || '' || NVL(:NEW.CDGRUPPROD,'')  || ' ' ||
                     'SubGrProd ' || '' || NVL(:NEW.CDSUBGRPROD,'') || ' ' ||
                     'FiliSubGr ' || '' || NVL(:NEW.CDFILISUBGR,'') || ' ' ||
                     'FilCota '   || '' || NVL(:NEW.CDFILCOTA,'')   || ' ' ||
                     'ColePreco ' || '' || NVL(:NEW.NRCOLEPRECO,'');
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDTIPPART||:NEW.NRSEQPART;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Filial '    || '' || NVL(:OLD.CDFILIAL,'')   || ' ' ||
                        'Produto '   || '' || NVL(:OLD.CDPRODUTO,'')  || ' ' ||
                        'Tipo '      || '' || NVL(:OLD.CDTIPPART,'')  || ' ' ||
                        'Sequencial '|| '' || NVL(:OLD.NRSEQPART,'')  || ' ' ||
                        'Marca '     || '' || NVL(:OLD.CDMARCA,'')     || ' ' ||
                        'Forne '     || '' || NVL(:OLD.CDFORNECED,'')  || ' ' ||
                        'GrupProd '  || '' || NVL(:OLD.CDGRUPPROD,'')  || ' ' ||
                        'SubGrProd ' || '' || NVL(:OLD.CDSUBGRPROD,'') || ' ' ||
                        'FiliSubGr ' || '' || NVL(:OLD.CDFILISUBGR,'') || ' ' ||
                        'FilCota '   || '' || NVL(:OLD.CDFILCOTA,'')   || ' ' ||
                        'ColePreco ' || '' || NVL(:OLD.NRCOLEPRECO,'');
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.CDPRODUTO||:OLD.CDTIPPART||:OLD.NRSEQPART;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
   VALUES
      ('PARTFILI',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

